
CoCoALib - Feature #1457

Make SmoothFactor interruptible

10 May 2020 11:54 - John Abbott

Status: Closed Start date: 10 May 2020

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Improving Estimated time: 0.99 hour

Target version: CoCoALib-0.99800 Spent time: 0.95 hour

Description

The following is disappointingly slow:

N := factorial(1000000);

facs := SmoothFactor(N, 1000000);

Slow and not interruptible.    

Make it interruptible!

Related issues:

Related to CoCoALib - Feature #718: Insert calls to CheckForInterrupt Closed 21 May 2015

Related to CoCoALib - Bug #1458: Redesign interrupt mechanism? Rejected 10 May 2020

History

#1 - 10 May 2020 11:54 - John Abbott

- Related to Feature #718: Insert calls to CheckForInterrupt added

#2 - 10 May 2020 11:54 - John Abbott

- Related to Bug #971: CheckForInterrupt does not work in the expected way added

#3 - 10 May 2020 11:54 - John Abbott

- Related to Design #1086: New design for interrupt mechanism added

#4 - 10 May 2020 11:55 - John Abbott

- Related to deleted (Bug #971: CheckForInterrupt does not work in the expected way)

#5 - 10 May 2020 11:55 - John Abbott

- Related to deleted (Design #1086: New design for interrupt mechanism)

#6 - 10 May 2020 11:57 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 50

- Estimated time set to 0.50 h

I have added the obvious call to CheckForInterrupt in the main loop in SmoothFactor (just for BigInt).

Testing led to a surprise -- see related issue.

#7 - 10 May 2020 12:06 - John Abbott
- Related to Bug #1458: Redesign interrupt mechanism? added

#8 - 16 Jun 2020 16:29 - John Abbott

- Status changed from In Progress to Resolved

- % Done changed from 50 to 80

The problem is that SmoothFactor has two (nested) loops either of which can be slow; but I had inserted a call to CheckForInterrupt only in the outer

loop.

Now it seems to work fine.

#9 - 16 Jun 2020 20:01 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

- Estimated time changed from 0.50 h to 0.99 h

Speed test was OK.  Also improved impl of SmoothFactor, but see #1463.

Checked in.

#10 - 26 Oct 2020 21:37 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100
